//+------------------------------------------------------------------+
//|                                                      MTF_RSI.mq4 |
//|                                                        avoitenko |
//|                        https://login.mql5.com/ru/users/avoitenko |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "https://login.mql5.com/ru/users/avoitenko"

#property indicator_separate_window
#property indicator_buffers 1

#property indicator_color1  SteelBlue
#property indicator_width1  2

//--- extern
extern int TimeFrame    =  PERIOD_H1;
extern int RsiPeriod    =  14;
extern int SmaSmoothing =  5;

//--- buffers
double rsiBuffer[];
double maBuffer[];

//---
bool returnBars;
bool calculateValue;

//+------------------------------------------------------------------+
//|   init()                                                         |
//+------------------------------------------------------------------+
int init()
{
   if(TimeFrame>0 && TimeFrame<Period())TimeFrame=Period();

   IndicatorBuffers(2);
   //---
   SetIndexBuffer(0,maBuffer);
   SetIndexBuffer(1,rsiBuffer);
   //---
   SetIndexStyle(0,DRAW_LINE);
   //---
   returnBars        = (TimeFrame == -1);
   calculateValue    = (TimeFrame == -2);

   return(0);
}

//+------------------------------------------------------------------+
//|   start()                                                        |
//+------------------------------------------------------------------+
int start()
{

   int i,limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars == 0)
   {
      maBuffer[0]=0;  
   }
   if(counted_bars > 0) counted_bars--;
   limit=Bars-counted_bars;

   //---     
   if(returnBars){rsiBuffer[0] = limit; return(0);}

   //---    
   if (calculateValue || TimeFrame==Period())
   {      	
      for(i=limit; i>=0; i--)
         rsiBuffer[i] = iRSI(NULL,0,RsiPeriod,PRICE_CLOSE,i);
 
      for(i=limit; i>=0; i--)
         maBuffer[i] = iMAOnArray(rsiBuffer,0,SmaSmoothing,0,MODE_SMA,i);

      return(0);
   }

   //---      
   int bars = iCustom(NULL,TimeFrame,WindowExpertName(),-1,1,0)*TimeFrame/Period();
   limit = MathMax(limit,MathMin(Bars-1,bars));
   
   //---  
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      //---  
      maBuffer[i] = iCustom(NULL,TimeFrame,WindowExpertName(),-2,RsiPeriod,SmaSmoothing,0,y);
   }              

   return(0);
}

